#include	<gl/glut.h>
#include	<gl/glaux.h>
#include	<stdio.h>
#include	<math.h>

float	angle  = 0.0f;

unsigned	      textureId    = -1;
AUX_RGBImageRec * localTexture = NULL;

void	init ()
{
	glClearColor ( 0, 0, 0, 1 );
	glEnable     ( GL_DEPTH_TEST );
	glEnable     ( GL_TEXTURE_2D );
	glEnable     ( GL_CULL_FACE  );
}

void	animate ()
{
	angle  += 1.0f;

	glutPostRedisplay ();
}


void	display ()
{
	glClear       ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glBindTexture ( GL_TEXTURE_2D, textureId );

	glTexEnvf     ( GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL );
	glTexGeni     ( GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP    );
	glTexGeni     ( GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP    );

	glPushMatrix ();

	glEnable  ( GL_TEXTURE_GEN_S );
	glEnable  ( GL_TEXTURE_GEN_T );

	glRotatef ( angle, 1, 1, 1 );

	glutSolidTorus(2.0,5.0,20,20);

	glDisable ( GL_TEXTURE_GEN_S );
	glDisable ( GL_TEXTURE_GEN_T );

	glPopMatrix ();

	
	glutSwapBuffers ();
}

void	reshape ( int w, int h )
{
   glViewport     ( 0, 0, w, h );
   glMatrixMode   ( GL_PROJECTION );
   glLoadIdentity ();
   gluPerspective ( 60.0, (GLfloat)w/(GLfloat)h, 1.0f, 60.0f );

   glMatrixMode   ( GL_MODELVIEW );
   glLoadIdentity ();
   gluLookAt      ( 0, 0, 25, 0, 0, 0, 0, 1, 0 );
}

void key ( unsigned char key, int x, int y )
{
  if ( key == 27 || key == 'q' || key == 'Q' )		//quit requested
    exit ( 0 );
}

int main ( int argc, char ** argv )
{
								//initialise glut
	glutInit            ( &argc, argv );
	glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );   
	glutInitWindowSize  ( 400, 400 );

								// create window
	int	glWin = glutCreateWindow ( "OpenGL example 8" );

	init();
								// register handlers
	glutDisplayFunc  ( display );
	glutReshapeFunc  ( reshape );
    glutKeyboardFunc ( key );
	glutIdleFunc     ( animate );

								// load texture
	localTexture = auxDIBImageLoad ( "..\\Textures\\stars.bmp" );

	glGenTextures   ( 1, &textureId );
	glBindTexture   ( GL_TEXTURE_2D, textureId );
	glPixelStorei   ( GL_UNPACK_ALIGNMENT, 1 );							// set 1-byte alignment

	glTexParameteri ( GL_TEXTURE_2D,  GL_TEXTURE_WRAP_S, GL_REPEAT );	// set texture to repeat mode
	glTexParameteri ( GL_TEXTURE_2D,  GL_TEXTURE_WRAP_T, GL_REPEAT );

	gluBuild2DMipmaps ( GL_TEXTURE_2D, GL_RGB, 
                        localTexture -> sizeX, localTexture -> sizeY, 
                        GL_RGB, GL_UNSIGNED_BYTE, 
                        localTexture -> data );

	glTexParameteri   ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );	
	glTexParameteri   ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );

	glutMainLoop ();

	return 0;
}
