#include	<gl/glut.h>
#include	<gl/glaux.h>
#include	<stdio.h>
#include	<math.h>

float	angle  = 0.0f;
float	lightPos [] = { 0, 0, 0, 1 };
float	lightAmb [] = { 0.5,  0.5, 0.5 };
float	lightDif [] = { 0,    0.7, 0.5 };

unsigned    mainTextureId = -1;
unsigned	envTextureId  = -1;

void    drawBox ( GLfloat x1, GLfloat x2, GLfloat y1, GLfloat y2, GLfloat z1, GLfloat z2 )
{
        glBegin ( GL_POLYGON );         // front face
          glNormal3f   ( 0.0, 0.0, 1.0 );

		  glTexCoord2f ( 0, 0 );
          glVertex3f   ( x1, y1, z2 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x2, y1, z2 );

		  glTexCoord2f ( 1, 1 );
          glVertex3f   ( x2, y2, z2 );

		  glTexCoord2f ( 0, 1 );
          glVertex3f   ( x1, y2, z2 );
        glEnd ();

        glBegin ( GL_POLYGON );         // back face
          glNormal3f ( 0.0, 0.0, -1.0 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x2, y1, z1 );

		  glTexCoord2f ( 0, 0 );
          glVertex3f   ( x1, y1, z1 );

		  glTexCoord2f ( 0, 1 );
          glVertex3f   ( x1, y2, z1 );

		  glTexCoord2f ( 1, 1 );
          glVertex3f   ( x2, y2, z1 );
        glEnd ();

        glBegin ( GL_POLYGON );         // left face
          glNormal3f ( -1.0, 0.0, 0.0 );

		  glTexCoord2f ( 0, 0 );
          glVertex3f   ( x1, y1, z1 );

		  glTexCoord2f ( 0, 1 );
          glVertex3f   ( x1, y1, z2 );

		  glTexCoord2f ( 1, 1 );
          glVertex3f   ( x1, y2, z2 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x1, y2, z1 );
        glEnd ();

        glBegin ( GL_POLYGON );         // right face
          glNormal3f ( 1.0, 0.0, 0.0 );

		  glTexCoord2f ( 0, 1 );
          glVertex3f   ( x2, y1, z2 );

		  glTexCoord2f ( 0, 0 );
          glVertex3f   ( x2, y1, z1 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x2, y2, z1 );

		  glTexCoord2f ( 1, 1 );
          glVertex3f   ( x2, y2, z2 );
        glEnd ();

        glBegin ( GL_POLYGON );         // top face
          glNormal3f ( 0.0, 1.0, 0.0 );

		  glTexCoord2f ( 0, 1 );
          glVertex3f   ( x1, y2, z2 );

		  glTexCoord2f ( 1, 1 );
          glVertex3f   ( x2, y2, z2 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x2, y2, z1 );

		  glTexCoord2f ( 0, 0 );
          glVertex3f   ( x1, y2, z1 );
        glEnd ();

        glBegin ( GL_POLYGON );         // bottom face
          glNormal3f ( 0.0, -1.0, 0.0 );

		  glTexCoord2f ( 1, 1 );
          glVertex3f   ( x2, y1, z2 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x1, y1, z2 );

		  glTexCoord2f ( 0, 0 );
          glVertex3f   ( x1, y1, z1 );

		  glTexCoord2f ( 1, 0 );
          glVertex3f   ( x2, y1, z1 );
        glEnd ();
}

void	init ()
{
	glClearColor ( 0, 0, 0, 1 );
	glEnable     ( GL_DEPTH_TEST );
	glEnable     ( GL_TEXTURE_2D );
	glEnable     ( GL_CULL_FACE  );
	glEnable     ( GL_BLEND );
	glDepthFunc  ( GL_LEQUAL );
	glBlendFunc  ( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
//	glLightfv    ( GL_LIGHT0, GL_POSITION, lightPos );
//	glLightfv    ( GL_LIGHT0, GL_AMBIENT,  lightAmb );	// Set The Ambient Lighting For Light0
//	glLightfv    ( GL_LIGHT0, GL_DIFFUSE,  lightDif );	// Set The Diffuse Lighting For Light0
//	glEnable     ( GL_LIGHTING );
}

void	animate ()
{
	angle  += 0.3f;

	glutPostRedisplay ();
}


void	display ()
{
	glClear      ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix ();

	glTranslatef ( 1.5f, 1.5f, 1.5f );		// move cube from the center
	glRotatef    ( angle, 1.0f, 1.0f, 0.0f );
	glTranslatef ( -1.5f, -1.5f, -1.5f );		// move cube into the center


								// draw main texture

//	glEnable      ( GL_LIGHT0  );
	glColor4f     ( 1, 1, 1, 1 );
	glBindTexture ( GL_TEXTURE_2D, mainTextureId );

	drawBox ( 1, 2, 1, 2, 1, 2 );

//	glDisable     ( GL_LIGHT0 );
								// draw env. mapped texture with alpha = 0.3
	glColor4f     ( 1, 1, 1, 0.3f );
	glBindTexture ( GL_TEXTURE_2D, envTextureId );

	glTexEnvf     ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL );
	glTexGeni     ( GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP    );
	glTexGeni     ( GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP    );

	glEnable  ( GL_TEXTURE_GEN_S );
	glEnable  ( GL_TEXTURE_GEN_T );

	drawBox ( 1, 2, 1, 2, 1, 2 );

	glDisable ( GL_TEXTURE_GEN_S );
	glDisable ( GL_TEXTURE_GEN_T );

	glPopMatrix ();

	
	glutSwapBuffers ();
}

void reshape ( int w, int h ) 
{
   glViewport     ( 0, 0, (GLsizei)w, (GLsizei)h );
   glMatrixMode   ( GL_PROJECTION );
   glLoadIdentity ();
   gluPerspective ( 60.0, (GLfloat)w/(GLfloat)h, 1.0, 60.0 );

   glMatrixMode   ( GL_MODELVIEW );
   glLoadIdentity ();
   gluLookAt      ( 0.0, 0.0, 0.0,		// eye
					1.0, 1.0, 1.0,		// center
					0.0, 1.0, 0.0 );
}

void key ( unsigned char key, int x, int y )
{
  if ( key == 27 || key == 'q' || key == 'Q' )		//quit requested
    exit ( 0 );
}

unsigned	loadTexture ( const char * fileName )
{
	AUX_RGBImageRec * localTexture;
	unsigned		  textureId = -1;

	localTexture = auxDIBImageLoad ( fileName );

	glGenTextures   ( 1, &textureId );
	glBindTexture   ( GL_TEXTURE_2D, textureId );
	glPixelStorei   ( GL_UNPACK_ALIGNMENT, 1 );							// set 1-byte alignment

	glTexParameteri ( GL_TEXTURE_2D,  GL_TEXTURE_WRAP_S, GL_REPEAT );	// set texture to repeat mode
	glTexParameteri ( GL_TEXTURE_2D,  GL_TEXTURE_WRAP_T, GL_REPEAT );

	gluBuild2DMipmaps ( GL_TEXTURE_2D, GL_RGB, 
                        localTexture -> sizeX, localTexture -> sizeY, 
                        GL_RGB, GL_UNSIGNED_BYTE, 
                        localTexture -> data );

	glTexParameteri   ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );	
	glTexParameteri   ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );

	return textureId;
}

int main ( int argc, char ** argv )
{
								// initialise glut
	glutInit            ( &argc, argv );
	glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );   
	glutInitWindowSize  ( 400, 400 );

								// create window
	int	glWin = glutCreateWindow ( "OpenGL example 9" );

	init ();
								// register handlers
	glutDisplayFunc  ( display );
	glutReshapeFunc  ( reshape );
    glutKeyboardFunc ( key );
	glutIdleFunc     ( animate );

								// load texture
	mainTextureId = loadTexture ( "..\\Textures\\block.bmp" );
	envTextureId  = loadTexture ( "..\\Textures\\stars.bmp" );


	glutMainLoop ();

	return 0;
}
